/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2206 from the
 * contents of X509.xs. Do not edit this file, edit X509.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "X509.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <openssl/asn1.h>
#include <openssl/objects.h>
#include <openssl/bio.h>
#include <openssl/crypto.h>
#include <openssl/err.h>
#include <openssl/evp.h>
#include <openssl/pem.h>
#include <openssl/x509.h>
#include <openssl/x509v3.h>

/* from openssl/apps/apps.h */
#define FORMAT_UNDEF    0
#define FORMAT_ASN1     1
#define FORMAT_TEXT     2
#define FORMAT_PEM      3
#define FORMAT_NETSCAPE 4
#define FORMAT_PKCS12   5
#define FORMAT_SMIME    6
#define FORMAT_ENGINE   7
#define FORMAT_IISSGC   8

#define NETSCAPE_CERT_HDR "certificate"

/* fake our package name */
typedef X509*  Crypt__OpenSSL__X509;
typedef X509_EXTENSION* Crypt__OpenSSL__X509__Extension;
typedef ASN1_OBJECT* Crypt__OpenSSL__X509__ObjectID;
typedef X509_NAME* Crypt__OpenSSL__X509__Name;
typedef X509_NAME_ENTRY* Crypt__OpenSSL__X509__Name_Entry;
typedef X509_CRL* Crypt__OpenSSL__X509__CRL;

/* 1.0 backwards compat */
#ifndef sk_OPENSSL_STRING_num
#define sk_OPENSSL_STRING_num sk_num
#endif

#ifndef sk_OPENSSL_STRING_value
#define sk_OPENSSL_STRING_value sk_value
#endif

/* Unicode 0xfffd */
static U8 utf8_substitute_char[3] = { 0xef, 0xbf, 0xbd };

/* stolen from OpenSSL.xs */
long bio_write_cb(struct bio_st *bm, int m, const char *ptr, int l, long x, long y) {

  if (m == BIO_CB_WRITE) {
    SV *sv = (SV *) BIO_get_callback_arg(bm);
    sv_catpvn(sv, ptr, l);
  }

  if (m == BIO_CB_PUTS) {
    SV *sv = (SV *) BIO_get_callback_arg(bm);
    l = strlen(ptr);
    sv_catpvn(sv, ptr, l);
  }

  return l;
}

static BIO* sv_bio_create(void) {

  SV *sv = newSVpvn("", 0);

  /* create an in-memory BIO abstraction and callbacks */
  BIO *bio = BIO_new(BIO_s_mem());

  BIO_set_callback(bio, bio_write_cb);
  BIO_set_callback_arg(bio, (void *)sv);

  return bio;
}

static SV* sv_bio_final(BIO *bio) {

  SV* sv;

  (void)BIO_flush(bio);
  sv = (SV *)BIO_get_callback_arg(bio);
  BIO_set_callback_arg(bio, (void *)NULL);
  BIO_set_callback(bio, (void *)NULL);
  BIO_free_all(bio);

  if (!sv) sv = &PL_sv_undef;

  return sv;
}

/* call this just before sv_bio_final if the BIO got an UTF8 encoded text and you want native perl utf-8 strings. */
static SV* sv_bio_utf8_on(BIO *bio) {

  SV* sv = (SV *)BIO_get_callback_arg(bio);

  /* Illegal utf-8 in the string */
  if (!sv_utf8_decode(sv)) {
    STRLEN len;
    SV *nsv = newSVpvn("", 0);

    const U8* start = (U8 *) SvPV(sv, len);
    const U8* end   = start + len;
    const U8* cur;

    while ((start < end) && !is_utf8_string_loclen(start, len, &cur, 0)) {
      sv_catpvn(nsv, (const char*)start, (cur - start) - 1);  /* text that was ok */
      sv_catpvn(nsv, (const char*)utf8_substitute_char, 3);  /* insert \x{fffd} */
      start = cur + 1;
      len = end - cur;
    }

    if (start < end) {
      sv_catpvn(nsv, (const char*)start, (cur - start) - 1);  /* rest of the string */
    }

    sv_copypv(sv, nsv);
    SvREFCNT_dec(nsv);
    sv_utf8_decode(sv); /* should be ok now */
  }

  return sv;
}

/*
static void sv_bio_error(BIO *bio) {

  SV* sv = (SV *)BIO_get_callback_arg(bio);
  if (sv) sv_free(sv);

  BIO_free_all (bio);
}
*/

static const char *ssl_error(void) {
  BIO *bio;
  SV *sv;
  STRLEN l;

  bio = sv_bio_create();
  ERR_print_errors(bio);
  sv = sv_bio_final(bio);
  ERR_clear_error();
  return SvPV(sv, l);
}

// Make a scalar ref to a class object
static SV* sv_make_ref(const char* class, void* object) {
  SV* rv;

  rv = newSV(0);
  sv_setref_pv(rv, class, (void*) object);

  if (! sv_isa(rv, class) ) {
    croak("Error creating reference to %s", class);
  }

  return rv;
}

/*
 * hash of extensions from x509.
 * no_name can be
 *  0: index by long name,
 *  1: index by oid string,
 *  2: index by short name
*/
static HV* hv_exts(X509* x509, int no_name) {
  X509_EXTENSION *ext;
  int i, c, r;
  size_t len = 128;
  char* key = NULL;
  SV* rv;

  HV* RETVAL = newHV();
  sv_2mortal((SV*)RETVAL);
  c = X509_get_ext_count(x509);

  if ( ! c > 0 ) {
    croak("No extensions found\n");
  }

  for (i = 0; i < c; i++) {
    r = 0;

    ext = X509_get_ext(x509, i);

    if (ext == NULL) croak("Extension %d unavailable\n", i);

    rv = sv_make_ref("Crypt::OpenSSL::X509::Extension", (void*)ext);

    if (no_name == 0 || no_name == 1) {

       key = malloc(sizeof(char) * (len + 1)); /*FIXME will it leak?*/
       r = OBJ_obj2txt(key, len, X509_EXTENSION_get_object(ext), no_name);

    } else if (no_name == 2) {

       key = (char*)OBJ_nid2sn(OBJ_obj2nid(X509_EXTENSION_get_object(ext)));
       r = strlen(key);
    }

    if (! hv_store(RETVAL, key, r, rv, 0) ) croak("Error storing extension in hash\n");
  }

  return RETVAL;
}

void _decode_netscape(BIO *bio, X509 *x509) {
#if OPENSSL_VERSION_NUMBER >= 0x10000000L

    NETSCAPE_X509 nx;
    ASN1_OCTET_STRING os;

    os.data   = (unsigned char *)NETSCAPE_CERT_HDR;
    os.length = strlen(NETSCAPE_CERT_HDR);
    nx.header = &os;
    nx.cert   = x509;

    ASN1_item_i2d_bio(ASN1_ITEM_rptr(NETSCAPE_X509), bio, &nx);

#else

    ASN1_HEADER ah;
    ASN1_OCTET_STRING os;

    os.data   = (unsigned char *)NETSCAPE_CERT_HDR;
    os.length = strlen(NETSCAPE_CERT_HDR);
    ah.header = &os;
    ah.data   = x509;
    ah.meth   = X509_asn1_meth();

    ASN1_i2d_bio((i2d_of_void*)i2d_ASN1_HEADER, bio, (unsigned char *)&ah);

#endif
}

#line 249 "X509.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 301 "X509.c"

XS(XS_Crypt__OpenSSL__X509_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	class = ST(0);
	Crypt__OpenSSL__X509	RETVAL;
#line 278 "X509.xs"
  if ((RETVAL = X509_new()) == NULL) {
    croak("X509_new");
  }

  if (!X509_set_version(RETVAL, 2)) {
    X509_free(RETVAL);
    croak ("%s - can't X509_set_version()", SvPV_nolen(class));
  }

  ASN1_INTEGER_set(X509_get_serialNumber(RETVAL), 0L);

#line 328 "X509.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::X509", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_new_from_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_new_from_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "class, string, format = FORMAT_PEM");
    {
	SV *	class = ST(0);
	SV *	string = ST(1);
	int	format;
#line 302 "X509.xs"
  BIO *bio;
  STRLEN len;
  char *cert;

#line 356 "X509.c"
	Crypt__OpenSSL__X509	RETVAL;

	if (items < 3)
	    format = FORMAT_PEM;
	else {
	    format = (int)SvIV(ST(2));
	}
#line 308 "X509.xs"
  cert = SvPV(string, len);

  if (ix == 1) {
    bio = BIO_new_file(cert, "r");
  } else {
    bio = BIO_new_mem_buf(cert, len);
  }

  if (!bio) croak("%s: Failed to create BIO", SvPV_nolen(class));

  /* this can come in any number of ways */
  if (format == FORMAT_ASN1) {

    RETVAL = (X509*)d2i_X509_bio(bio, NULL);

  } else {

    RETVAL = (X509*)PEM_read_bio_X509(bio, NULL, NULL, NULL);
  }

  BIO_free_all(bio);

  if (!RETVAL) croak("%s: failed to read X509 certificate.", SvPV_nolen(class));

#line 389 "X509.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::X509", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__OpenSSL__X509	x509;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Crypt::OpenSSL::X509::DESTROY",
			"x509");
#line 341 "X509.xs"
  if (x509) X509_free(x509); x509 = 0;
#line 422 "X509.c"
	PUTBACK;
	return;
    }
}


XS(XS_Crypt__OpenSSL__X509___X509_cleanup); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509___X509_cleanup)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "void");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 348 "X509.xs"
  CRYPTO_cleanup_all_ex_data();
  ERR_free_strings();
  ERR_remove_state(0);
  EVP_cleanup();
#line 447 "X509.c"
	PUTBACK;
	return;
    }
}


XS(XS_Crypt__OpenSSL__X509_accessor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_accessor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 369 "X509.xs"
  BIO *bio;
  X509_NAME *name;

#line 471 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"x509", "Crypt::OpenSSL::X509");
#line 374 "X509.xs"
  bio = sv_bio_create();

  /* this includes both subject and issuer since they are so much alike */
  if (ix == 1 || ix == 2) {

    if (ix == 1) {
      name = X509_get_subject_name(x509);
    } else {
      name = X509_get_issuer_name(x509);
    }

    /* this is prefered over X509_NAME_oneline() */
    X509_NAME_print_ex(bio, name, 0, (XN_FLAG_SEP_CPLUS_SPC | ASN1_STRFLGS_UTF8_CONVERT) & ~ASN1_STRFLGS_ESC_MSB);

    /* this need not be pure ascii, try to get a native perl character string with * utf8 */
    sv_bio_utf8_on(bio);

  } else if (ix == 3) {

    i2a_ASN1_INTEGER(bio, x509->cert_info->serialNumber);

  } else if (ix == 4) {

    BIO_printf(bio, "%08lx", X509_subject_name_hash(x509));

  } else if (ix == 5) {

    ASN1_TIME_print(bio, X509_get_notBefore(x509));

  } else if (ix == 6) {

    ASN1_TIME_print(bio, X509_get_notAfter(x509));

  } else if (ix == 7) {

    int j;
    STACK_OF(OPENSSL_STRING) *emlst = X509_get1_email(x509);

    for (j = 0; j < sk_OPENSSL_STRING_num(emlst); j++) {
      BIO_printf(bio, "%s", sk_OPENSSL_STRING_value(emlst, j));
    }

    X509_email_free(emlst);

  } else if (ix == 8) {

    i2a_ASN1_INTEGER(bio, x509->cert_info->version);

  } else if (ix == 9) {

    i2a_ASN1_OBJECT(bio, x509->sig_alg->algorithm);
  }

  RETVAL = sv_bio_final(bio);

#line 538 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_subject_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_subject_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
	Crypt__OpenSSL__X509__Name	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"x509", "Crypt::OpenSSL::X509");
#line 441 "X509.xs"
  if (ix == 1) {
    RETVAL = X509_get_subject_name(x509);
  } else {
    RETVAL = X509_get_issuer_name(x509);
  }

#line 576 "X509.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::X509::Name", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_sig_print); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_sig_print)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 455 "X509.xs"
  BIO *bio;
  unsigned char *s;
  int n,i;

#line 601 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::sig_print",
			"x509", "Crypt::OpenSSL::X509");
#line 461 "X509.xs"
  n   = x509->signature->length;
  s   = x509->signature->data;
  bio = sv_bio_create();

  for (i=0; i<n; i++) {
    BIO_printf(bio, "%02x", s[i]);
  }

  RETVAL = sv_bio_final(bio);
#line 622 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_as_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_as_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "x509, format = FORMAT_PEM");
    {
	Crypt__OpenSSL__X509	x509;
	int	format;
#line 479 "X509.xs"
  BIO *bio;

#line 646 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::as_string",
			"x509", "Crypt::OpenSSL::X509");

	if (items < 2)
	    format = FORMAT_PEM;
	else {
	    format = (int)SvIV(ST(1));
	}
#line 483 "X509.xs"
  bio = sv_bio_create();

  /* get the certificate back out in a specified format. */

  if (format == FORMAT_PEM) {

    PEM_write_bio_X509(bio, x509);

  } else if (format == FORMAT_ASN1) {

    i2d_X509_bio(bio, x509);

  } else if (format == FORMAT_NETSCAPE) {

    _decode_netscape(bio, x509);
  }

  RETVAL = sv_bio_final(bio);

#line 683 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_modulus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_modulus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 510 "X509.xs"
  EVP_PKEY *pkey;
  BIO *bio;

#line 707 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::modulus",
			"x509", "Crypt::OpenSSL::X509");
#line 515 "X509.xs"
  pkey = X509_get_pubkey(x509);
  bio  = sv_bio_create();

  if (pkey == NULL) {

    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Modulus is unavailable\n");
  }

  if (pkey->type == EVP_PKEY_RSA) {

    BN_print(bio, pkey->pkey.rsa->n);

  } else if (pkey->type == EVP_PKEY_DSA) {

    BN_print(bio, pkey->pkey.dsa->pub_key);

  } else {

    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Wrong Algorithm type\n");
  }

  RETVAL = sv_bio_final(bio);

  EVP_PKEY_free(pkey);

#line 748 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_exponent); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_exponent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 552 "X509.xs"
  EVP_PKEY *pkey;
  BIO *bio;

#line 773 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"x509", "Crypt::OpenSSL::X509");
#line 559 "X509.xs"
  pkey = X509_get_pubkey(x509);
  bio  = sv_bio_create();

  /* Silence warning */
  if (ix)

  if (pkey == NULL) {
    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Exponent is unavailable\n");
  }

  if (pkey->type == EVP_PKEY_RSA) {
    BN_print(bio, pkey->pkey.rsa->e);
  } else {
    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Wrong Algorithm type -- exponent only available with RSA\n");
  }

  RETVAL = sv_bio_final(bio);

  EVP_PKEY_free(pkey);

#line 809 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_fingerprint_md5); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_fingerprint_md5)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 595 "X509.xs"
  const EVP_MD *mds[] = { EVP_md5(), EVP_sha1() };
  unsigned char md[EVP_MAX_MD_SIZE];
  int i;
  unsigned int n;
  BIO *bio;

#line 837 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"x509", "Crypt::OpenSSL::X509");
#line 603 "X509.xs"
  bio = sv_bio_create();

  if (!X509_digest(x509, mds[ix], md, &n)) {

    BIO_free_all(bio);
    croak("Digest error: %s", ssl_error());
  }

  BIO_printf(bio, "%02X", md[0]);
  for (i = 1; i < n; i++) {
    BIO_printf(bio, ":%02X", md[i]);
  }

  RETVAL = sv_bio_final(bio);

#line 864 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_checkend); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_checkend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "x509, checkoffset");
    {
	Crypt__OpenSSL__X509	x509;
	IV	checkoffset = (IV)SvIV(ST(1));
#line 627 "X509.xs"
  time_t now;

#line 888 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::checkend",
			"x509", "Crypt::OpenSSL::X509");
#line 631 "X509.xs"
  now = time(NULL);

  /* given an offset in seconds, will the certificate be expired? */
  if (ASN1_UTCTIME_cmp_time_t(X509_get_notAfter(x509), now + (int)checkoffset) == -1) {
    RETVAL = &PL_sv_yes;
  } else {
    RETVAL = &PL_sv_no;
  }

#line 909 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_pubkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_pubkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 648 "X509.xs"
  EVP_PKEY *pkey;
  BIO *bio;

#line 933 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::pubkey",
			"x509", "Crypt::OpenSSL::X509");
#line 653 "X509.xs"
  pkey = X509_get_pubkey(x509);
  bio  = sv_bio_create();

  if (pkey == NULL) {

    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Public Key is unavailable\n");
  }

  if (pkey->type == EVP_PKEY_RSA) {

    PEM_write_bio_RSAPublicKey(bio, pkey->pkey.rsa);

  } else if (pkey->type == EVP_PKEY_DSA) {

    PEM_write_bio_DSA_PUBKEY(bio, pkey->pkey.dsa);

  } else {

    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Wrong Algorithm type\n");
  }

  EVP_PKEY_free(pkey);

  RETVAL = sv_bio_final(bio);

#line 974 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_pub_exponent); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_pub_exponent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 689 "X509.xs"
    EVP_PKEY *pkey;
    BIO *bio;
#line 997 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::pub_exponent",
			"x509", "Crypt::OpenSSL::X509");
#line 692 "X509.xs"
    bio = sv_bio_create();
    pkey = X509_get_pubkey(x509);
    BN_print(bio,pkey->pkey.rsa->e);
    RETVAL = sv_bio_final(bio);
#line 1013 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_pubkey_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_pubkey_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 703 "X509.xs"
        EVP_PKEY *pkey;
#line 1035 "X509.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::pubkey_type",
			"x509", "Crypt::OpenSSL::X509");
#line 705 "X509.xs"
        RETVAL=NULL;
        pkey = X509_get_pubkey(x509);
        if(pkey->type == EVP_PKEY_DSA){
            RETVAL="dsa";
        }
        else if(pkey->type == EVP_PKEY_RSA){
            RETVAL="rsa";
        }
#line 1056 "X509.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_num_extensions); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_num_extensions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::num_extensions",
			"x509", "Crypt::OpenSSL::X509");
#line 721 "X509.xs"
  RETVAL = X509_get_ext_count(x509);

#line 1089 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_extension); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_extension)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "x509, i");
    {
	Crypt__OpenSSL__X509	x509;
	int	i = (int)SvIV(ST(1));
#line 732 "X509.xs"
  X509_EXTENSION *ext;
  int c;

#line 1113 "X509.c"
	Crypt__OpenSSL__X509__Extension	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::extension",
			"x509", "Crypt::OpenSSL::X509");
#line 736 "X509.xs"
  ext = NULL;

  c = X509_get_ext_count(x509);

  if (!c > 0) {
    croak("No extensions found\n");
  } else if (i >= c || i < 0) {
    croak("Requested extension index out of range\n");
  } else {
    ext = X509_get_ext(x509, i);
  }

  if (ext == NULL) {
    // X509_EXTENSION_free(ext); // not needed?
    croak("Extension unavailable\n");
  }

  RETVAL = ext;

#line 1144 "X509.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::X509::Extension", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_extensions); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_extensions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
	HV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"x509", "Crypt::OpenSSL::X509");
#line 768 "X509.xs"
  RETVAL = hv_exts(x509, ix);

#line 1178 "X509.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Extension_critical); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Extension_critical)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::critical",
			"ext", "Crypt::OpenSSL::X509::Extension");
#line 781 "X509.xs"
  if (ext == NULL) {
    croak("No extension supplied\n");
  }

  RETVAL = X509_EXTENSION_get_critical(ext);

#line 1216 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Extension_object); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Extension_object)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
	Crypt__OpenSSL__X509__ObjectID	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::object",
			"ext", "Crypt::OpenSSL::X509::Extension");
#line 796 "X509.xs"
  if (ext == NULL) {
    croak("No extension supplied\n");
  }

  RETVAL = X509_EXTENSION_get_object(ext);

#line 1252 "X509.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::X509::ObjectID", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Extension_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Extension_value)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 810 "X509.xs"
  BIO* bio;

#line 1275 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::value",
			"ext", "Crypt::OpenSSL::X509::Extension");
#line 813 "X509.xs"
  bio  = sv_bio_create();

  if (ext == NULL) {
    BIO_free_all(bio);
    croak("No extension supplied\n");
  }

  ASN1_STRING_print(bio, X509_EXTENSION_get_data(ext));

  RETVAL = sv_bio_final(bio);

#line 1298 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Extension_to_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Extension_to_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 832 "X509.xs"
  BIO* bio;

#line 1321 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::to_string",
			"ext", "Crypt::OpenSSL::X509::Extension");
#line 835 "X509.xs"
  bio = sv_bio_create();

  if (ext == NULL) {
    BIO_free_all(bio);
    croak("No extension supplied\n");
  }

  X509V3_EXT_print(bio, ext, 0, 0);

  RETVAL = sv_bio_final(bio);

#line 1344 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Extension_basicC); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Extension_basicC)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ext, value");
    {
	Crypt__OpenSSL__X509__Extension	ext;
	char *	value = (char *)SvPV_nolen(ST(1));
#line 855 "X509.xs"
  BASIC_CONSTRAINTS *bs;
  int ret = 0;

#line 1369 "X509.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::basicC",
			"ext", "Crypt::OpenSSL::X509::Extension");
#line 860 "X509.xs"
  /* retrieve the value of CA or pathlen in basicConstraints */
  bs = X509V3_EXT_d2i(ext);

  if (strcmp(value, "ca") == 0) {
    ret = bs->ca ? 1 : 0;

  } else if (strcmp(value, "pathlen") == 0) {
    ret = bs->pathlen ? 1 : 0;
  }

  BASIC_CONSTRAINTS_free(bs);

  RETVAL = ret;

#line 1396 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Extension_ia5string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Extension_ia5string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 882 "X509.xs"
  ASN1_IA5STRING *str;
  BIO *bio;

#line 1419 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::ia5string",
			"ext", "Crypt::OpenSSL::X509::Extension");
#line 887 "X509.xs"
  /* retrieving the value of an ia5string object */
  bio = sv_bio_create();
  str = X509V3_EXT_d2i(ext);
  BIO_printf(bio,"%s", str->data);
  ASN1_IA5STRING_free(str);

  RETVAL = sv_bio_final(bio);

#line 1439 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Extension_bit_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Extension_bit_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 903 "X509.xs"
  int i, nid;
  ASN1_OBJECT *object;
  ASN1_BIT_STRING *bit_str;
  int string[10];
  BIO *bio;

#line 1466 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::bit_string",
			"ext", "Crypt::OpenSSL::X509::Extension");
#line 910 "X509.xs"
  bio = sv_bio_create();

  object = X509_EXTENSION_get_object(ext);
  nid = OBJ_obj2nid(object);
  bit_str = X509V3_EXT_d2i(ext);

  if (nid == NID_key_usage) {

    for (i = 0; i < 9; i++) {
      string[i] = (int)ASN1_BIT_STRING_get_bit(bit_str, i);
      BIO_printf(bio, "%d", string[i]);
    }

  } else if (nid == NID_netscape_cert_type) {

    for (i = 0; i < 8; i++) {
      string[i] = (int)ASN1_BIT_STRING_get_bit(bit_str, i);
      BIO_printf(bio, "%d",  string[i]);
    }
  }

  RETVAL = sv_bio_final(bio);

#line 1501 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Extension_extendedKeyUsage); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Extension_extendedKeyUsage)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 941 "X509.xs"
  BIO *bio;
  STACK_OF(ASN1_OBJECT) *extku;
  int nid;
  const char *value;

#line 1527 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::extendedKeyUsage",
			"ext", "Crypt::OpenSSL::X509::Extension");
#line 948 "X509.xs"
  bio   = sv_bio_create();
  extku = (STACK_OF(ASN1_OBJECT)*) X509V3_EXT_d2i(ext);

  while(sk_ASN1_OBJECT_num(extku) > 0) {
    nid = OBJ_obj2nid(sk_ASN1_OBJECT_pop(extku));
    value = OBJ_nid2sn(nid);
    BIO_printf(bio, "%s", value);
    BIO_printf(bio, " ");
  }

  RETVAL = sv_bio_final(bio);

#line 1551 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Extension_auth_att); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Extension_auth_att)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 968 "X509.xs"
  AUTHORITY_KEYID *akid;

#line 1574 "X509.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::auth_att",
			"ext", "Crypt::OpenSSL::X509::Extension");
#line 972 "X509.xs"
  akid   = X509V3_EXT_d2i(ext);
  RETVAL = akid->keyid ? 1 : 0;

#line 1590 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Extension_keyid_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Extension_keyid_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 983 "X509.xs"
  AUTHORITY_KEYID *akid;
  ASN1_OCTET_STRING *skid;
  int nid;
  ASN1_OBJECT *object;
  BIO *bio;

#line 1616 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::keyid_data",
			"ext", "Crypt::OpenSSL::X509::Extension");
#line 991 "X509.xs"
  bio    = sv_bio_create();
  object = X509_EXTENSION_get_object(ext);
  nid    = OBJ_obj2nid(object);

  if (nid == NID_authority_key_identifier) {

    akid = X509V3_EXT_d2i(ext);
    BIO_printf(bio, "%s", akid->keyid->data);

  } else if (nid == NID_subject_key_identifier) {

    skid = X509V3_EXT_d2i(ext);
    BIO_printf(bio, "%s", skid->data);
  }

  RETVAL = sv_bio_final(bio);

#line 1645 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__ObjectID_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__ObjectID_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	Crypt__OpenSSL__X509__ObjectID	obj;
#line 1017 "X509.xs"
  char buf[128];

#line 1668 "X509.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::ObjectID")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Crypt__OpenSSL__X509__ObjectID,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::ObjectID::name",
			"obj", "Crypt::OpenSSL::X509::ObjectID");
#line 1021 "X509.xs"
  if (obj == NULL) {
    croak("No ObjectID supplied\n");
  }

  (void)OBJ_obj2txt(buf, 128, obj, 0);

  RETVAL = buf;

#line 1689 "X509.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__ObjectID_oid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__ObjectID_oid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	Crypt__OpenSSL__X509__ObjectID	obj;
#line 1037 "X509.xs"
  char buf[128];

#line 1711 "X509.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::ObjectID")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Crypt__OpenSSL__X509__ObjectID,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::ObjectID::oid",
			"obj", "Crypt::OpenSSL::X509::ObjectID");
#line 1041 "X509.xs"
  if (obj == NULL) {
    croak("No ObjectID supplied\n");
  }

  (void)OBJ_obj2txt(buf, 128, obj, 1);

  RETVAL = buf;

#line 1732 "X509.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Name_as_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Name_as_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	Crypt__OpenSSL__X509__Name	name;
#line 1059 "X509.xs"
  BIO *bio;

#line 1754 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name = INT2PTR(Crypt__OpenSSL__X509__Name,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Name::as_string",
			"name", "Crypt::OpenSSL::X509::Name");
#line 1063 "X509.xs"
  bio = sv_bio_create();
  /* this is prefered over X509_NAME_oneline() */
  X509_NAME_print_ex(bio, name, 0, XN_FLAG_SEP_CPLUS_SPC);

  RETVAL = sv_bio_final(bio);

#line 1772 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Name_entries); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Name_entries)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	Crypt__OpenSSL__X509__Name	name;
#line 1077 "X509.xs"
  int i, c;
  SV* rv;

#line 1796 "X509.c"
	AV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name = INT2PTR(Crypt__OpenSSL__X509__Name,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Name::entries",
			"name", "Crypt::OpenSSL::X509::Name");
#line 1082 "X509.xs"
  RETVAL = newAV();
  sv_2mortal((SV*)RETVAL);

  c = X509_NAME_entry_count(name);

  for (i = 0; i < c; i++) {
    rv = sv_make_ref("Crypt::OpenSSL::X509::Name_Entry", (void*)X509_NAME_get_entry(name, i));
    av_push(RETVAL, rv);
  }

#line 1818 "X509.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Name_get_index_by_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Name_get_index_by_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "name, type, lastpos = -1");
    {
	Crypt__OpenSSL__X509__Name	name;
	const char*	type = (const char *)SvPV_nolen(ST(1));
	int	lastpos;
#line 1109 "X509.xs"
  int nid, i;

#line 1844 "X509.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name = INT2PTR(Crypt__OpenSSL__X509__Name,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"name", "Crypt::OpenSSL::X509::Name");

	if (items < 3)
	    lastpos = -1;
	else {
	    lastpos = (int)SvIV(ST(2));
	}
#line 1113 "X509.xs"
  if (ix == 1 || ix == 3) {
    nid = OBJ_ln2nid(type);
  } else if (ix == 4 || ix == 5) {
    nid = OBJ_obj2nid(OBJ_txt2obj(type, /*oid*/ 1));
  } else {
    nid = OBJ_sn2nid(type);
  }

  if (!nid) {
    croak("Unknown type");
  }

  i = X509_NAME_get_index_by_NID(name, nid, lastpos);

  if (ix == 2 || ix == 3 || ix == 4) { /* has_entry */
    RETVAL = (i > lastpos)?1:0;
  } else { /* get_index */
    RETVAL = i;
  }

#line 1883 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Name_get_entry_by_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Name_get_entry_by_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "name, type, lastpos = -1");
    {
	Crypt__OpenSSL__X509__Name	name;
	const char*	type = (const char *)SvPV_nolen(ST(1));
	int	lastpos;
#line 1146 "X509.xs"
  int nid, i;

#line 1908 "X509.c"
	Crypt__OpenSSL__X509__Name_Entry	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name = INT2PTR(Crypt__OpenSSL__X509__Name,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"name", "Crypt::OpenSSL::X509::Name");

	if (items < 3)
	    lastpos = -1;
	else {
	    lastpos = (int)SvIV(ST(2));
	}
#line 1150 "X509.xs"
  if (ix == 1) {
    nid = OBJ_ln2nid(type);
  } else {
    nid = OBJ_sn2nid(type);
  }

  if (!nid) {
    croak("Unknown type");
  }

  i = X509_NAME_get_index_by_NID(name, nid, lastpos);
  RETVAL = X509_NAME_get_entry(name, i);

#line 1939 "X509.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::X509::Name_Entry", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Name_Entry_as_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Name_Entry_as_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "name_entry, ln = 0");
    {
	Crypt__OpenSSL__X509__Name_Entry	name_entry;
	int	ln;
#line 1178 "X509.xs"
  BIO *bio;
  const char *n;
  int nid;

#line 1966 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name_Entry")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name_entry = INT2PTR(Crypt__OpenSSL__X509__Name_Entry,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"name_entry", "Crypt::OpenSSL::X509::Name_Entry");

	if (items < 2)
	    ln = 0;
	else {
	    ln = (int)SvIV(ST(1));
	}
#line 1183 "X509.xs"
  bio = sv_bio_create();
  nid = OBJ_obj2nid(X509_NAME_ENTRY_get_object(name_entry));

  if (ix == 1 || ln) {
    n = OBJ_nid2ln(nid);
  } else {
    n = OBJ_nid2sn(nid);
  }

  BIO_printf(bio, "%s=", n);

  ASN1_STRING_print_ex(bio, X509_NAME_ENTRY_get_data(name_entry), ASN1_STRFLGS_UTF8_CONVERT & ~ASN1_STRFLGS_ESC_MSB);

  sv_bio_utf8_on(bio);

  RETVAL = sv_bio_final(bio);

#line 2001 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Name_Entry_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Name_Entry_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "name_entry, ln = 0");
    {
	Crypt__OpenSSL__X509__Name_Entry	name_entry;
	int	ln;
#line 1212 "X509.xs"
  BIO *bio;
  const char *n;
  int nid;

#line 2028 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name_Entry")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name_entry = INT2PTR(Crypt__OpenSSL__X509__Name_Entry,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"name_entry", "Crypt::OpenSSL::X509::Name_Entry");

	if (items < 2)
	    ln = 0;
	else {
	    ln = (int)SvIV(ST(1));
	}
#line 1217 "X509.xs"
  bio = sv_bio_create();
  nid = OBJ_obj2nid(X509_NAME_ENTRY_get_object(name_entry));

  if (ix == 1 || ln) {
    n = OBJ_nid2ln(nid);
  } else {
    n = OBJ_nid2sn(nid);
  }

  BIO_printf(bio, "%s", n);
  RETVAL = sv_bio_final(bio);

#line 2058 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Name_Entry_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Name_Entry_value)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "name_entry");
    {
	Crypt__OpenSSL__X509__Name_Entry	name_entry;
#line 1237 "X509.xs"
  BIO *bio;

#line 2081 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name_Entry")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name_entry = INT2PTR(Crypt__OpenSSL__X509__Name_Entry,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Name_Entry::value",
			"name_entry", "Crypt::OpenSSL::X509::Name_Entry");
#line 1240 "X509.xs"
  bio = sv_bio_create();
  ASN1_STRING_print(bio, X509_NAME_ENTRY_get_data(name_entry));
  RETVAL = sv_bio_final(bio);

#line 2097 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "name_entry, asn1_type =  V_ASN1_PRINTABLESTRING");
    {
	Crypt__OpenSSL__X509__Name_Entry	name_entry;
	int	asn1_type;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name_Entry")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name_entry = INT2PTR(Crypt__OpenSSL__X509__Name_Entry,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"name_entry", "Crypt::OpenSSL::X509::Name_Entry");

	if (items < 2)
	    asn1_type = V_ASN1_PRINTABLESTRING;
	else {
	    asn1_type = (int)SvIV(ST(1));
	}
#line 1259 "X509.xs"
  RETVAL = (X509_NAME_ENTRY_get_data(name_entry)->type == (ix == 1 ? asn1_type : ix));

#line 2139 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509__Name_Entry_encoding); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509__Name_Entry_encoding)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "name_entry");
    {
	Crypt__OpenSSL__X509__Name_Entry	name_entry;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name_Entry")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name_entry = INT2PTR(Crypt__OpenSSL__X509__Name_Entry,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Name_Entry::encoding",
			"name_entry", "Crypt::OpenSSL::X509::Name_Entry");
#line 1269 "X509.xs"
  RETVAL = NULL;

  if (X509_NAME_ENTRY_get_data(name_entry)->type == V_ASN1_PRINTABLESTRING) {
    RETVAL = "printableString";

  } else if(X509_NAME_ENTRY_get_data(name_entry)->type == V_ASN1_IA5STRING) {
    RETVAL = "ia5String";

  } else if(X509_NAME_ENTRY_get_data(name_entry)->type == V_ASN1_UTF8STRING) {
    RETVAL = "utf8String";
  }

#line 2182 "X509.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_CRL_new_from_crl_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_CRL_new_from_crl_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "class, string, format = FORMAT_PEM");
    {
	SV *	class = ST(0);
	SV *	string = ST(1);
	int	format;
#line 1296 "X509.xs"
  BIO *bio;
  STRLEN len;
  char *crl;

#line 2209 "X509.c"
	Crypt__OpenSSL__X509__CRL	RETVAL;

	if (items < 3)
	    format = FORMAT_PEM;
	else {
	    format = (int)SvIV(ST(2));
	}
#line 1302 "X509.xs"
  crl = SvPV(string, len);

  if (ix == 1) {
    bio = BIO_new_file(crl, "r");
  } else {
    bio = BIO_new_mem_buf(crl, len);
  }

  if (!bio) {
    croak("%s: Failed to create BIO", SvPV_nolen(class));
  }

  if (format == FORMAT_ASN1) {
    RETVAL = (X509_CRL*)d2i_X509_CRL_bio(bio, NULL);
  } else {
    RETVAL = (X509_CRL*)PEM_read_bio_X509_CRL(bio, NULL, NULL, NULL);
  }

  if (!RETVAL) {
    croak("%s: failed to read X509 certificate.", SvPV_nolen(class));
  }

  BIO_free(bio);

#line 2242 "X509.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::X509::CRL", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__X509_CRL_CRL_accessor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__X509_CRL_CRL_accessor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	Crypt__OpenSSL__X509__CRL	crl;
#line 1338 "X509.xs"
  BIO *bio;
  X509_NAME *name;

#line 2267 "X509.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::X509::CRL")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    crl = INT2PTR(Crypt__OpenSSL__X509__CRL,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"crl", "Crypt::OpenSSL::X509::CRL");
#line 1342 "X509.xs"
  bio = sv_bio_create();

  if (ix == 1) {
    name = X509_CRL_get_issuer(crl);
    sv_bio_utf8_on(bio);
    X509_NAME_print_ex(bio, name, 0, (XN_FLAG_SEP_CPLUS_SPC | ASN1_STRFLGS_UTF8_CONVERT) & ~ASN1_STRFLGS_ESC_MSB);
    RETVAL = sv_bio_final(bio);

  } else if (ix == 2) {
    i2a_ASN1_OBJECT(bio, crl->sig_alg->algorithm);
  }

  RETVAL = sv_bio_final(bio);

#line 2293 "X509.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__OpenSSL__X509); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__OpenSSL__X509)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXS("Crypt::OpenSSL::X509::new", XS_Crypt__OpenSSL__X509_new, file);
        cv = newXS("Crypt::OpenSSL::X509::new_from_string", XS_Crypt__OpenSSL__X509_new_from_string, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Crypt::OpenSSL::X509::new_from_file", XS_Crypt__OpenSSL__X509_new_from_string, file);
        XSANY.any_i32 = 1 ;
        newXS("Crypt::OpenSSL::X509::DESTROY", XS_Crypt__OpenSSL__X509_DESTROY, file);
        newXS("Crypt::OpenSSL::X509::__X509_cleanup", XS_Crypt__OpenSSL__X509___X509_cleanup, file);
        cv = newXS("Crypt::OpenSSL::X509::email", XS_Crypt__OpenSSL__X509_accessor, file);
        XSANY.any_i32 = 7 ;
        cv = newXS("Crypt::OpenSSL::X509::accessor", XS_Crypt__OpenSSL__X509_accessor, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Crypt::OpenSSL::X509::notBefore", XS_Crypt__OpenSSL__X509_accessor, file);
        XSANY.any_i32 = 5 ;
        cv = newXS("Crypt::OpenSSL::X509::hash", XS_Crypt__OpenSSL__X509_accessor, file);
        XSANY.any_i32 = 4 ;
        cv = newXS("Crypt::OpenSSL::X509::subject", XS_Crypt__OpenSSL__X509_accessor, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509::serial", XS_Crypt__OpenSSL__X509_accessor, file);
        XSANY.any_i32 = 3 ;
        cv = newXS("Crypt::OpenSSL::X509::notAfter", XS_Crypt__OpenSSL__X509_accessor, file);
        XSANY.any_i32 = 6 ;
        cv = newXS("Crypt::OpenSSL::X509::version", XS_Crypt__OpenSSL__X509_accessor, file);
        XSANY.any_i32 = 8 ;
        cv = newXS("Crypt::OpenSSL::X509::sig_alg_name", XS_Crypt__OpenSSL__X509_accessor, file);
        XSANY.any_i32 = 9 ;
        cv = newXS("Crypt::OpenSSL::X509::issuer", XS_Crypt__OpenSSL__X509_accessor, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("Crypt::OpenSSL::X509::subject_name", XS_Crypt__OpenSSL__X509_subject_name, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509::issuer_name", XS_Crypt__OpenSSL__X509_subject_name, file);
        XSANY.any_i32 = 2 ;
        newXS("Crypt::OpenSSL::X509::sig_print", XS_Crypt__OpenSSL__X509_sig_print, file);
        newXS("Crypt::OpenSSL::X509::as_string", XS_Crypt__OpenSSL__X509_as_string, file);
        newXS("Crypt::OpenSSL::X509::modulus", XS_Crypt__OpenSSL__X509_modulus, file);
        cv = newXS("Crypt::OpenSSL::X509::exponent", XS_Crypt__OpenSSL__X509_exponent, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Crypt::OpenSSL::X509::pub_exponent", XS_Crypt__OpenSSL__X509_exponent, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509::fingerprint_sha1", XS_Crypt__OpenSSL__X509_fingerprint_md5, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509::fingerprint_md5", XS_Crypt__OpenSSL__X509_fingerprint_md5, file);
        XSANY.any_i32 = 0 ;
        newXS("Crypt::OpenSSL::X509::checkend", XS_Crypt__OpenSSL__X509_checkend, file);
        newXS("Crypt::OpenSSL::X509::pubkey", XS_Crypt__OpenSSL__X509_pubkey, file);
        newXS("Crypt::OpenSSL::X509::pub_exponent", XS_Crypt__OpenSSL__X509_pub_exponent, file);
        newXS("Crypt::OpenSSL::X509::pubkey_type", XS_Crypt__OpenSSL__X509_pubkey_type, file);
        newXS("Crypt::OpenSSL::X509::num_extensions", XS_Crypt__OpenSSL__X509_num_extensions, file);
        newXS("Crypt::OpenSSL::X509::extension", XS_Crypt__OpenSSL__X509_extension, file);
        cv = newXS("Crypt::OpenSSL::X509::extensions_by_long_name", XS_Crypt__OpenSSL__X509_extensions, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Crypt::OpenSSL::X509::extensions_by_name", XS_Crypt__OpenSSL__X509_extensions, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("Crypt::OpenSSL::X509::extensions_by_oid", XS_Crypt__OpenSSL__X509_extensions, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509::extensions", XS_Crypt__OpenSSL__X509_extensions, file);
        XSANY.any_i32 = 0 ;
        newXS("Crypt::OpenSSL::X509::Extension::critical", XS_Crypt__OpenSSL__X509__Extension_critical, file);
        newXS("Crypt::OpenSSL::X509::Extension::object", XS_Crypt__OpenSSL__X509__Extension_object, file);
        newXS("Crypt::OpenSSL::X509::Extension::value", XS_Crypt__OpenSSL__X509__Extension_value, file);
        newXS("Crypt::OpenSSL::X509::Extension::to_string", XS_Crypt__OpenSSL__X509__Extension_to_string, file);
        newXS("Crypt::OpenSSL::X509::Extension::basicC", XS_Crypt__OpenSSL__X509__Extension_basicC, file);
        newXS("Crypt::OpenSSL::X509::Extension::ia5string", XS_Crypt__OpenSSL__X509__Extension_ia5string, file);
        newXS("Crypt::OpenSSL::X509::Extension::bit_string", XS_Crypt__OpenSSL__X509__Extension_bit_string, file);
        newXS("Crypt::OpenSSL::X509::Extension::extendedKeyUsage", XS_Crypt__OpenSSL__X509__Extension_extendedKeyUsage, file);
        newXS("Crypt::OpenSSL::X509::Extension::auth_att", XS_Crypt__OpenSSL__X509__Extension_auth_att, file);
        newXS("Crypt::OpenSSL::X509::Extension::keyid_data", XS_Crypt__OpenSSL__X509__Extension_keyid_data, file);
        newXS("Crypt::OpenSSL::X509::ObjectID::name", XS_Crypt__OpenSSL__X509__ObjectID_name, file);
        newXS("Crypt::OpenSSL::X509::ObjectID::oid", XS_Crypt__OpenSSL__X509__ObjectID_oid, file);
        newXS("Crypt::OpenSSL::X509::Name::as_string", XS_Crypt__OpenSSL__X509__Name_as_string, file);
        newXS("Crypt::OpenSSL::X509::Name::entries", XS_Crypt__OpenSSL__X509__Name_entries, file);
        cv = newXS("Crypt::OpenSSL::X509::Name::get_index_by_oid_type", XS_Crypt__OpenSSL__X509__Name_get_index_by_type, file);
        XSANY.any_i32 = 5 ;
        cv = newXS("Crypt::OpenSSL::X509::Name::get_index_by_type", XS_Crypt__OpenSSL__X509__Name_get_index_by_type, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Crypt::OpenSSL::X509::Name::has_long_entry", XS_Crypt__OpenSSL__X509__Name_get_index_by_type, file);
        XSANY.any_i32 = 3 ;
        cv = newXS("Crypt::OpenSSL::X509::Name::has_entry", XS_Crypt__OpenSSL__X509__Name_get_index_by_type, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("Crypt::OpenSSL::X509::Name::get_index_by_long_type", XS_Crypt__OpenSSL__X509__Name_get_index_by_type, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509::Name::has_oid_entry", XS_Crypt__OpenSSL__X509__Name_get_index_by_type, file);
        XSANY.any_i32 = 4 ;
        cv = newXS("Crypt::OpenSSL::X509::Name::get_entry_by_type", XS_Crypt__OpenSSL__X509__Name_get_entry_by_type, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Crypt::OpenSSL::X509::Name::get_entry_by_long_type", XS_Crypt__OpenSSL__X509__Name_get_entry_by_type, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509::Name_Entry::as_long_string", XS_Crypt__OpenSSL__X509__Name_Entry_as_string, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509::Name_Entry::as_string", XS_Crypt__OpenSSL__X509__Name_Entry_as_string, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Crypt::OpenSSL::X509::Name_Entry::long_type", XS_Crypt__OpenSSL__X509__Name_Entry_type, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509::Name_Entry::type", XS_Crypt__OpenSSL__X509__Name_Entry_type, file);
        XSANY.any_i32 = 0 ;
        newXS("Crypt::OpenSSL::X509::Name_Entry::value", XS_Crypt__OpenSSL__X509__Name_Entry_value, file);
        cv = newXS("Crypt::OpenSSL::X509::Name_Entry::is_ia5string", XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString, file);
        XSANY.any_i32 = V_ASN1_IA5STRING ;
        cv = newXS("Crypt::OpenSSL::X509::Name_Entry::is_asn1_type", XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509::Name_Entry::is_printableString", XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString, file);
        XSANY.any_i32 = V_ASN1_PRINTABLESTRING ;
        cv = newXS("Crypt::OpenSSL::X509::Name_Entry::is_utf8string", XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString, file);
        XSANY.any_i32 = V_ASN1_UTF8STRING ;
        newXS("Crypt::OpenSSL::X509::Name_Entry::encoding", XS_Crypt__OpenSSL__X509__Name_Entry_encoding, file);
        cv = newXS("Crypt::OpenSSL::X509_CRL::new_from_crl_string", XS_Crypt__OpenSSL__X509_CRL_new_from_crl_string, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Crypt::OpenSSL::X509_CRL::new_from_crl_file", XS_Crypt__OpenSSL__X509_CRL_new_from_crl_string, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509_CRL::CRL_sig_alg_name", XS_Crypt__OpenSSL__X509_CRL_CRL_accessor, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("Crypt::OpenSSL::X509_CRL::CRL_issuer", XS_Crypt__OpenSSL__X509_CRL_CRL_accessor, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Crypt::OpenSSL::X509_CRL::CRL_accessor", XS_Crypt__OpenSSL__X509_CRL_CRL_accessor, file);
        XSANY.any_i32 = 0 ;
    }

    /* Initialisation Section */

#line 244 "X509.xs"
{
  HV *stash = gv_stashpvn("Crypt::OpenSSL::X509", 20, TRUE);

  struct { char *n; I32 v; } Crypt__OpenSSL__X509__const[] = {

  {"OPENSSL_VERSION_NUMBER", OPENSSL_VERSION_NUMBER},
  {"FORMAT_UNDEF", FORMAT_UNDEF},
  {"FORMAT_ASN1", FORMAT_ASN1},
  {"FORMAT_TEXT", FORMAT_TEXT},
  {"FORMAT_PEM", FORMAT_PEM},
  {"FORMAT_NETSCAPE", FORMAT_NETSCAPE},
  {"FORMAT_PKCS12", FORMAT_PKCS12},
  {"FORMAT_SMIME", FORMAT_SMIME},
  {"FORMAT_ENGINE", FORMAT_ENGINE},
  {"FORMAT_IISSGC", FORMAT_IISSGC},
  {"V_ASN1_PRINTABLESTRING",  V_ASN1_PRINTABLESTRING},
  {"V_ASN1_UTF8STRING",  V_ASN1_UTF8STRING},
  {"V_ASN1_IA5STRING",  V_ASN1_IA5STRING},
  {Nullch,0}};

  char *name;
  int i;

  for (i = 0; (name = Crypt__OpenSSL__X509__const[i].n); i++) {
    newCONSTSUB(stash, name, newSViv(Crypt__OpenSSL__X509__const[i].v));
  }
}

#line 2471 "X509.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

